mob/verb
	Private_Say(msg as text)
		set category="GM"
		set hidden=1
		if(!GM)return
		if(!msg) return
		for(var/mob/M in world)if(M.GM)M<<output("<b><font color=red>(GM)([usr]: [msg])","worldbox")
mob/Mod
	verb
		Create_Pylon()
			set category="GM"
			new/obj/pylon(loc)
		Summon_To_Spawn()
			set category="GM"
			var/list/choose=list()
			for(var/mob/M in world)if(M.client)choose.Add(M)
			var/cancel="Cancel"
			choose+=cancel
			var/mob/M=input("Which character do you want to send to spawn?") as null|anything in choose
			if(M)
				M.shadowoff()
				M.shadowparaoff()
				M.shadowsewingoff()
			switch(alert("His current location is [M.x],[M.y],[M.z]. Are you sure you want to summon him to spawn?","","Yes","No"))
				if("Yes")
					if(M.village=="Leaf")M.loc=locate(238,345,1)
					if(M.village=="Sand")M.loc=locate(100,166,1)
					if(M.village=="Sound")M.loc=locate(383,48,1)
					if(M.village=="None")
						src<<"<b>He's a missing-nin. He gets summoned to your location."
						M.loc=loc
					for(var/mob/ironsand/M2 in world)if(M2.owner==M)del M2
		GM_House()
			set category="GM"
			if(z!=40)
				savedloc=loc
				for(var/mob/ironsand/M in world)if(M.owner==src)del M
				loc=locate(126,87,1)
				usr<<"<b>You have teleported to the GM house."
			else
				loc=savedloc
				for(var/mob/ironsand/M in world)if(M.owner==src)del M
				if(z==1)usr<<"<b>You have to use the portal to get out of the GM house."
		Boot()
			set category="GM"
			var/list/choose=list()
			for(var/mob/M in world)choose.Add(M)
			var/cancel="Cancel"
			choose+=cancel
			var/mob/M=input("Which character do you want to boot?") as null|anything in choose
			if(M:key==""||M:key=="Truezdale 69"||M.key==""||!M||M==cancel)
				if(M)M<<"[src] tried to boot you."
				return
			var/T="not stated"
			T=input("Why are you booting [M]?","Boot") as text|null
			world<<output("<b><font color=white>[M]<font color=red> has been booted by <font color=white>[usr]<font color=red>. The reason is <font color=white>[T]<font color=red>.","worldbox")
			del(M.client)
			if(M)del(M)
		Summon(mob/M in world)
			set category="GM"
			if(M.intut)
				src<<output("<b>He's in the tutorial. Unless you want to bug the game I suggest you to teleport to him instead.","infobox")
				return
			if(M!=src)M.loc=loc
			M.shadowoff()
			for(var/mob/ironsand/M2 in world)if(M2.owner==M)del M2
			M.shadowparaoff()
			M.shadowsewingoff()
		Teleport(mob/M in world)
			set category = "GM"
			loc=M.loc
			for(var/mob/ironsand/M2 in world)if(M2.owner==src)del M2
			shadowoff()
			shadowsewingoff()
			shadowparaoff()
		Jail()
			set category="GM"
			var/list/choose=list()
			for(var/mob/M in world)choose.Add(M)
			var/cancel="Cancel"
			choose+=cancel
			var/mob/M=input("Which character do you want to jail?") as null|anything in choose
			if(!M)return
			var/input=input("Why are you jailing [M]? You may skip this if you want.")as null|text
			if(!input)input="not stated"
			var/input2=input("How many seconds do you want to jail him for?(Maximum of 86400)")as num
			if(input2<=0||input2==null)return
			if(input2>=1)input2=input2
			if(input2>86400)input2=86400
			if(!M.jailtime)
				if(input2<86400)
					world<<output("<b><font color=white>[M]<font color=red> has been jailed by <font color=white>[usr]<font color=red>. He is jailed for <font color=white>[input2]<font color=red> seconds and the reason is <font color=white>[input]<font color=red>.","worldbox")
					M.jailtime=input2
					M.jailtime()
				else
					M.jailtime=86400
					M.jailtime()
					world<<output("<b><font color=white>[M]<font color=red> has been jailed by <font color=white>[usr]<font color=red>. He is jailed for an indefinite amount of time and the reason is <font color=white>[input]<font color=red>.","worldbox")
			else
				if((input2+M.jailtime)<=86400)
					M.jailtime+=input2
					world<<output("<b><font color=white>[M]<font color=red>'s jail time has been extended to <font color=white>[M.jailtime] seconds<font color=red> by <font color=white>[usr]<font color=red>.The reason for the extension is <font color=white>[input]<font color=red>.","worldbox")
				else
					M.jailtime=86400
					world<<output("<b><font color=white>[M]<font color=red>'s jail time has been extended to <font color=white>24 hours<font color=red> by <font color=white>[usr]<font color=red>.The reason for the extension is <font color=white>[input]<font color=red>.","worldbox")
		Unjail()
			set category="GM"
			var/list/choose=list()
			for(var/mob/M in world)if(M.jailtime)choose.Add(M)
			var/cancel="Cancel"
			choose+=cancel
			var/mob/M=input("Which character do you want to unjail?") as null|anything in choose
			if(!M)return
			M.jailtime=0
			world<<output("<b><font color=white>[M]<font color=red> has been unjailed by <font color=white>[usr]<font color=red>.","worldbox")
		Mute()
			set category="GM"
			var/list/choose=list()
			for(var/mob/M in world)choose.Add(M)
			var/cancel="Cancel"
			choose+=cancel
			var/mob/M=input("Which character do you want to mute?") as null|anything in choose
			if(!M)return
			var/input=input("Why are you muting [M]? You may skip this if you want.")as null|text
			if(!input)input="not stated"
			var/input2=input("How many seconds do you want to mute him for?(Upwards of 36000 means permenant)")as num
			if(input2<=0||input2==null)return
			if(input2>=1)input2=input2
			if(input2>36000)input2=36001
			if(input2<=36000)
				if(!M.muted)
					world<<output("<b><font color=white>[M]<font color=red> has been muted by <font color=white>[usr]<font color=red>. He is muted for <font color=white>[input2]<font color=red> seconds and the reason is <font color=white>[input]<font color=red>.","worldbox")
					M.muted=input2
					M.muteproc()
				else
					M.muted+=input2
					world<<output("<b><font color=white>[M]<font color=red>'s mute time has been extended by <font color=white>[usr]<font color=red>. He has <font color=white>[M.muted]<font color=red> seconds of being muted left and the reason for the extension is <font color=white>[input]<font color=red>.","worldbox")
			else
				M.muted=1
				world<<output("<b><font color=white>[M]<font color=red> has been muted by <font color=white>[usr]<font color=red>. He is muted for an indefinite amount of time and the reason is <font color=white>[input]<font color=red>.","worldbox")
		Unmute()
			set category="GM"
			var/list/choose=list()
			for(var/mob/M in world)if(M.muted)choose.Add(M)
			var/cancel="Cancel"
			choose+=cancel
			var/mob/M=input("Which character do you want to unmute?") as null|anything in choose
			if(!M)return
			M.muted=0
			world<<output("<b><font color=white>[M]<font color=red> has been unmuted by <font color=white>[usr]<font color=red>.","worldbox")
		Ban()
			set category = "GM"
			switch(input("What would you like to do?")in list("Choose from a list.","Type the key in.","Cancel"))
				if("Choose from a list.")
					var/list/choose=list()
					for(var/mob/M in world)if(!M.GM)if(M.client)choose.Add(M)
					var/cancel="Cancel"
					choose+=cancel
					var/mob/M=input("Which character do you want to key ban?") as null|anything in choose
					if(!M||M=="Cancel"||M==usr||M.key=="Truezdale 69"||M.key==""||M.key=="")return
					keyban:Add(M.key)
					if(M.key!=null)keyban[M.key]="[M.client.address]"
					var/T="[M.ckey]"
					if(length(T)<6)T+="000000"
					T=copytext(T,1,6)
					ipban:Add("[T]-[M.client.address]")
					world<<output("<b><font color=white>[usr]<font color=red> has banned <font color=white>[M]<font color=red>.","worldbox")
					del(M.client)
					if(M)del(M)
				if("Type the key in.")
					var/M=input("Please type in the key you wish to ban. (Case Sensitive)") as text
					if(!M||M in keyban||M==key||M=="Truezdale 69"||M==""||M=="")return
					for(var/mob/G in world)if(G.key==M)if(!G.GM>GM)return
					keyban:Add(M)
					world<<output("<b><font color=white>[usr]<font color=red> has banned <font color=white>[M]<font color=red>.","worldbox")
					for(var/mob/G in world)if(G.key==M)
						var/T="[G.ckey]"
						if(length(T)<6)T+="000000"
						T=copytext(T,1,6)
						ipban:Add("[T]-[G.client.address]")
						del G.client
						if(M)del M
		Rename()
			set category="GM"
			var/list/choose=list()
			for(var/mob/M in world)choose.Add(M)
			var/cancel="Cancel"
			choose+=cancel
			var/mob/M=input("Which character do you want to rename?") as null|anything in choose
			if(M.key=="Truezdale 69"||M.key==""||M.key=="")if(M!=usr)return
			var/newn=input("What do you want to change [M]'s name to?")as text
			if(newn=="")return
			world<<output("<b><font color=white>[usr]<font color=red> has changed <font color=white>[M]<font color=red>'s name to <font color=white>[newn].<font color=red>","worldbox")
			var/firstletter=copytext(ckey, 1, 2)
			var/savefile/F = new("Saves/[firstletter]/[ckey].sav")
			F.cd = "/[ckey]"
			F.dir.Remove(M.name)
			M.name=newn
			M.savedname=M.name
		Unban()
			set category="GM"
			var/list/choose=list()
			for(var/T in keyban)choose.Add(T)
			for(var/T in ipban)choose.Add(T)
			var/cancel="Cancel"
			choose+=cancel
			var/K=input("Which character do you want to unban?") as null|anything in choose
			if(!K||K=="Cancel")return
			var/confirm=input("Are you sure you want to unban [K]?") in list("Yes","No")
			switch(confirm)
				if("Yes")
					keyban:Remove(K)
					ipban:Remove(K)
					world<<output("<b>[usr]<font color=red> has unbanned <font color=white>[K]<font color=red>.","worldbox")
		Strip_Naked()
			set category="GM"
			var/list/choose=list()
			for(var/mob/M in world)choose.Add(M)
			var/cancel="Cancel"
			choose+=cancel
			var/mob/M=input("Which character do you want to strip naked?") as null|anything in choose
			if(!M)return
			world<<output("<b>[src]<font color=red> has stripped <font color=white>[M]<font color=red> naked.","worldbox")
			if(M==cancel)return
			M.weapon=0
			M.weaponsh=0
			M.pant2=0
			M.shirt2=0
			M.armor=0
			M.headgear=0
			M.cloak=0
			M.shirt=0
			M.mask=0
			M.pant=0
			M.shoes=0
			M.gloves=0
			M.belt=0
			M.fullbody=0
			M.special=0
			M.overlay()
		Reset_Variables()
			set category="GM"
			var/list/choose=list()
			for(var/mob/M in world)choose.Add(M)
			var/cancel="Cancel"
			choose+=cancel
			var/mob/M=input("Which character do you want to fix?") as null|anything in choose
			if(!M)return
			world<<output("<b>[src]<font color=red> has resetted all of <font color=white>[M]<font color=red>'s variables.","worldbox")
			if(M==cancel)return
			M.overlay()
			M.iconrefresh()
			M.cdelay1=0
			M.cdelay2=0
			M.cdelay3=0
			M.cdelay4=0
			M.cdelay5=0
			M.cdelay6=0
			M.vdelay1=0
			M.vdelay2=0
			M.vdelay3=0
			M.vdelay4=0
			M.rasengandelay=0
			M.sclonedelay=0
			M.busy=null
			M.flicked=0
			M.substitution=0
			M.attacking=0
			M.shadow=0
			M.paralysed=0
			M.imitation=null
			M.imitated=null
			M.paraown=0
			M.freeze=0
			M.teleport=0
			M.seals=0
			M.ingenin=0
			M.inchunin=0
			M.sealpass=0
			M.onwater=0
			M.swim=0
			M.blind=0
			M.addled=0
			M.resting=0
			M.talknum=0
			M.moving=0
			M.clonedelay=0
			M.clone=0
			M.muted=0
			M.buttonjam=0
			M.henge=0
			M.dous=0
			M.sharingan=0
			M.byakugan=0
			M.cloned=0
			M.shadowdelay=0
			M.sandshield=0
			M.kstoggle="Shuriken"
			M.shield=0
			M.smite=0
			M.pill=""
			M.gassed=0
			M.overlay()
		Delete(M as obj in view(8))
			set category="GM"
			if(!istype(M,/obj/jutsu))del(M)
		OOC(msg as text)
			set category = "GM"
			if(!msg) return
			world<<output("<b><font color=red>[src.status] [src.name]: <font color=silver>[html_encode(copytext(msg,1,200))]","worldbox")
mob/GM
	verb
		World_Save()
			set category = "GM"
			world<<output("<b><font color=yellow>Starting World Save","worldbox")
			sleep(5)
			world<<output("<b><font color=yellow>Saving...","worldbox")
			for(var/client/c in world) c.mob.Save()
			world<<output("<b><font color=yellow>World Save Complete","worldbox")
		Announce(txt as text)
			set category="GM"
			world<<output("<font size=3><font color=red><b><center>[usr] would like to announce:<font size=2><br><font color=silver>[txt]","worldbox")
		Ghost_Mode()
			set category = "GM"
			if(density)
				density=0
				src<<output("<b>You can now pass through objects.","infobox")
			else
				density=1
				src<<output("<b>You are now solid.","infobox")
		Create()
			set category="GM"
			var/varItem
			var/varType=input("What do you want to create?","Create") in list("Mob","Object","Turf","Cancel")
			if(varType=="Cancel")return
			if(varType=="Object")varItem = input("What do you want to make?","Create obj") in typesof(/obj) + list("Cancel")
			if(varType=="Mob")varItem = input("What do you want to make?","Create mob") in typesof(/mob) + list("Cancel")
			if(varType=="Turf")varItem = input("What do you want to make?","Create turf") in typesof(/turf) + list("Cancel")
			if(varItem=="Cancel")return
			new varItem(locate(x,y,z))
			for(var/mob/M in world)if(GM<3)M<<output("<b><font color=white>Game Master [usr]<font color=red> just created a <font color=white>[varItem]<font color=red> in the cooridinates: [x],[y],[z].","worldbox")
		Teleloc()
			set category="GM"
			set name="Teleport: Location"
			var/Z
			switch(input("Which dimention do you want to go to?") in list("Indoor","Outdoor","Upstairs","Cancel"))
				if("Indoor")Z=1
				if("Outdoor")Z=2
				if("Upstairs")Z=3
				if("Cancel")return
			var/X=input("What horizontal tile do you want to go to? (Current: [x])") as num
			var/Y=input("What vertical tile do you want to go to? (Current: [y])") as num
			loc=locate(X,Y,Z)
			for(var/mob/ironsand/M in world)if(M.owner==src)del M
		World_Peace_Toggle()
			set category="GM"
			if(worldpeace==0)
				world<<output("<b>[usr]<font color=red> wrote a peace treaty for all 3 villages.","worldbox")
				worldpeace=1
			else
				world<<output("<b>[usr]<font color=red> vetoed the peace treaty for all 3 villages.","worldbox")
				worldpeace=0
		Reboot()
			set name="Reboot"
			set category="GM"
			switch(alert("Are you sure you want to Reboot?","Reboot","Yes","No"))
				if("Yes")
					world<<output("<b><font color=red><font size=3>[usr] activated world reboot. It will trigger in 10 seconds.","worldbox")
					sleep(100)
					world<<output("<b><font color=red><font size=3>World is now rebooting.","worldbox")
					for(var/client/M in world)M.SaveMob()
					sleep(20)
					world.Reboot()
		World_Privacy_Toggle()
			set category="GM"
			if(!privacy)
				world<<output("<b>[usr]<font color=red> made the world private. Now only Game Masters can log on.","worldbox")
				privacy=1
			else
				world<<output("<b>[usr]<font color=red> made the world open to public.","worldbox")
				privacy=0
		Invincibility()
			set category = "GM"
			if(!npc)
				npc=1
				src<<output("<b>You are now invincible. The death proc will be cancelled before it takes effect.","infobox")
			else
				npc=0
				src<<output("<b>You deactivated your invincibility.","infobox")
		Edit(var/O as obj|mob|turf in range(12))
			set category="GM"
			var/variable=input("Which variable would you like to edit?","Edit") in O:vars + list("Cancel")
			if(variable=="Cancel")return
			var/default
			var/typeof = O:vars[variable]
			if(isnull(typeof))default = "Text"
			else if(isnum(typeof))default = "Number"
			else if(istext(typeof))default = "Text"
			else if(isloc(typeof))default = "Reference"
			else if(isicon(typeof))
				typeof = "\icon[typeof]"
				default = "Icon"
			else if(istype(typeof,/atom) || istype(typeof,/datum)) default = "Type"
			else if(istype(typeof,/list))default = "List"
			else if(istype(typeof,/client))default = "Cancel"
			else default = "File"
			var/clan = input("What kind of variable?","Variable Type",default) in list("Text","Number","Type","Reference","Icon","File","Restore to default","List","Clear","Cancel")
			switch(clan)
				if("Restore to default")O:vars[variable] = initial(O:vars[variable])
				if("Text")O:vars[variable] = input("Enter new text:","Text",O:vars[variable]) as text
				if("Number")O:vars[variable] = input("Enter new number:","Number",O:vars[variable]) as num
				if("Type")O:vars[variable] = input("Enter type:","Type",O:vars[variable]) in typesof(/obj,/mob,/area,/turf)
				if("Reference")O:vars[variable] = input("Select reference:","Reference",O:vars[variable]) as mob|obj|turf|area in world
				if("File")O:vars[variable] = input("Pick file:","File",O:vars[variable]) as file
				if("Icon")O:vars[variable] = input("Pick icon:","Icon",O:vars[variable]) as icon
				if("List")input("This is what's in [variable]") in O:vars[variable] + list("Close")
				if("Clear")if(alert("Are you sure you want to clear this variable?","Clear","Yes","No") == "Yes")O:vars[variable] = null
mob/Owner
	verb
		Get_Jutsu()
			set category = "Owner"
			var/jutsus = list()
			for(var/obj/jutsu/j in world)
				if(j.z == 1) jutsus += j
			var/obj/o = input("Which jutsu would you like to get?") as null|anything in jutsus
			if(!o) return
			src.contents += o
		Death_Cage_Toggle()
			set category="Owner"
			if(!penison)
				penison=1
				for(var/obj/cumcannon/M in world)M.penison()
				src<<output("<b>You have now activated the cum cannons.","infobox")
			else
				penison=0
				src<<output("<b>You deactivated the cum cannons.","infobox")
		Clear_Scoreboard()
			set category="Owner"
			switch(alert("Are you sure you want to clear the scoreboard?","","Yes","No"))
				if("Yes")
					var/hubkeys=params2list(world.GetScores())
					var/scoreset[0]
					scoreset["Level"]=null
					scoreset["Stats"]=null
					scoreset["Kills"]=null
					scoreset["Ryo"]=null
					scoreset["Bounty"]=null
					scoreset["Deaths"]=null
					scoreset=list2params(scoreset)
					for(var/key in hubkeys)world.SetScores(key,scoreset)
		Remove_Admin()
			set category="Owner"
			var/list/choose=list()
			for(var/mob/M in world)if(M.key!="MassiveCodyStorm"&&M.key!=""&&M.key!="")choose.Add(M)
			var/cancel="Cancel"
			choose+=cancel
			var/mob/M=input("Which person do you want to remove GM powers to?") as null|anything in choose
			M.verbs-=typesof(/mob/GM/verb)
			M.verbs-=typesof(/mob/Mod/verb)
			M.status="Player"
			M.GM=0
			M.overlay()
			world<<output("<font color=red><b>GM Notice: [usr] stripped [M] of his GM/Mod status!","worldbox")
		Make_Game_Master()
			set category="Owner"
			var/list/choose=list()
			for(var/mob/M in world)choose.Add(M)
			var/cancel="Cancel"
			choose+=cancel
			var/mob/M=input("Who do you want to give GM to?") as null|anything in choose
			M.verbs+=typesof(/mob/GM/verb)
			M.verbs+=typesof(/mob/Mod/verb)
			M.status="Game Master"
			M.GM=2
			M.overlay()
			for(var/mob/G in world)if(G.GM)G<<output("<font color=red><b>GM Notice: [usr] has made [M] a Game Master!","worldbox")
		Make_Moderator()
			set category="Owner"
			var/list/choose=list()
			for(var/mob/M in world)choose.Add(M)
			var/cancel="Cancel"
			choose+=cancel
			var/mob/M=input("Who do you want to give Mod to?") as null|anything in choose
			if(M=="Cancel")return
			M.verbs+=typesof(/mob/Mod/verb)
			M.status="Mod"
			M.GM=1
			M.overlay()
			for(var/mob/G in world)if(G.GM)G<<output("<font color=red><b>GM Notice: [usr] has made [M] a Mod!","worldbox")
		Close_World()
			set category="Owner"
			switch(input("Are you sure you want to close world?") in list("Yes","No"))
				if("Yes")
					world<<output("<b><font color=lime><font size=4>[usr] is shutting down world.","worldbox")
					for(var/mob/player/M in world)if(M.client)M.client.SaveMob()
					spawn(10)for(var/mob/player/M in world)if(M.client&&M!=usr)M.Logout()
					spawn(40)del world
		Secondary_Announce(txt as text)
			set category = "Owner"
			if(txt!="tapswitch")
				world<<output("[txt]","worldbox")
			else
				if(!tapping)
					tapping=1
					src<<output("<b>You are now tapping the radio line.","infobox")
				else
					tapping=0
					src<<output("<b>You stopped tapping the radio line.","infobox")
		Remove_Kage()
			set category="Owner"
			var/list/choose=list()
			for(var/mob/M in world)if(M.rank=="Hokage"||M.rank=="Kazekage"||M.rank=="Sound Leader")choose.Add(M)
			var/cancel="Cancel"
			choose+=cancel
			var/mob/M=input("Which character do you want to strip of Kage rank?(They must be online)") as null|anything in choose
			if(!M)return
			M.tmprank="ANBU"
			M.rank="ANBU"
			M.overlay()
			M.verbs-=typesof(/mob/Kage/verb)
			for(var/obj/items/equippable/Hokage_Hat/M2 in M)del M2
			for(var/obj/items/equippable/Hokage_Suit/M2 in M)del M2
			for(var/obj/items/equippable/Kazekage_Hat/M2 in M)del M2
			for(var/obj/items/equippable/Kazekage_Suit/M2 in M)del M2
			for(var/obj/items/equippable/Sound_Leader_Suit/M2 in M)del M2
			world<<output("<b><font color=white>[M]<font size=2><font color=red> has been stripped of his kage rank and has been turned into an ANBU by [usr]!","worldbox")
		Appoint_Kage()
			set category = "Owner"
			switch(input("Which village?")in list("Leaf","Sand","Sound","Akatsuki","Cancel"))
				if("Akatsuki")
					var/list/choose=list()
					for(var/mob/M in world)if(M.village=="Akatsuki"&&M.rank!="Academy Student"&&M.rank!="Genin")choose.Add(M)
					var/cancel="Cancel"
					choose+=cancel
					var/mob/M=input("Which character do you want to appoint as Akatsuki Leader?") as null|anything in choose
					if(!M)return
					M.rank="Leader"
					M.tmprank="Leader"
					M.verbs+=typesof(/mob/Kage/Akatsuki/verb)
					var/S=0
					for(var/obj/jutsu/Advanced_Tracking/M2 in M)S=1
					if(!S)
						new/obj/jutsu/Advanced_Tracking(M)
						M<<output("<b><font color=lime>You have learned Advanced Tracking!","infobox")
					M.overlay()
					spawn()
						var/before=world.GetMedal("Village Leader",M)
						if(!before)
							spawn()world.SetMedal("Village Leader",M)
							world<<output("<b><font color=yellow>Medal Info: [M]([M.key]) has earned the Village Leader medal!","worldbox")
					world<<output("<b><font color=white>[M]<font size=3><font color=red> has been appointed by [usr] as Akatsuki Leader!","worldbox")
					M<<"<font size=2>As [M.rank] you control one of the most powerful alliances in the game. You can change the Akatsuki hideout password, and invite/decruit members."
				if("Leaf")
					var/list/choose=list()
					for(var/mob/M in world)if(M.village=="Leaf"&&M.rank!="Academy Student"&&M.rank!="Genin")choose.Add(M)
					var/cancel="Cancel"
					choose+=cancel
					var/mob/M=input("Which character do you want to appoint as Hokage?") as null|anything in choose
					if(!M)return
					M.rank="Hokage"
					M.tmprank="Hokage"
					M.verbs+=typesof(/mob/Kage/verb)
					var/S=0
					for(var/obj/jutsu/Advanced_Tracking/M2 in M)S=1
					if(!S)
						new/obj/jutsu/Advanced_Tracking(M)
						M<<output("<b><font color=lime>You have learned Advanced Tracking!","infobox")
					new/obj/items/equippable/Hokage_Hat(M)
					new/obj/items/equippable/Hokage_Suit(M)
					M.overlay()
					spawn()
						var/before=world.GetMedal("Village Leader",M)
						if(!before)
							spawn()world.SetMedal("Village Leader",M)
							world<<output("<b><font color=yellow>Medal Info: [M]([M.key]) has earned the Village Leader medal!","worldbox")
					world<<output("<b><font color=white>[M]<font size=3><font color=red> has been appointed by [usr] as Hokage!","worldbox")
					M<<"<font size=2>As [M.rank] you are able to control what the village priority is from your building and appoint Jounins. You are also the most important member of your village and dying will cause your village's influence to go down alot and your training speed are halfened. As [M.rank] you are responsible for your village's influence, top wanted bounty and assassinations. Be sure to help Academy Students and Genins when they need help in the game."
				if("Sand")
					var/list/choose=list()
					for(var/mob/M in world)if(M.village=="Sand"&&M.rank!="Academy Student"&&M.rank!="Genin")choose.Add(M)
					var/cancel="Cancel"
					choose+=cancel
					var/mob/M=input("Which character do you want to appoint as Kazekage?") as null|anything in choose
					if(!M)return
					M.rank="Kazekage"
					M.tmprank="Kazekage"
					M.verbs+=typesof(/mob/Kage/verb)
					var/S=0
					for(var/obj/jutsu/Advanced_Tracking/M2 in M)S=1
					if(!S)
						new/obj/jutsu/Advanced_Tracking(M)
						M<<output("<b><font color=lime>You have learned Advanced Tracking!","infobox")
					new/obj/items/equippable/Kazekage_Hat(M)
					new/obj/items/equippable/Kazekage_Suit(M)
					M.overlay()
					spawn()
						var/before=world.GetMedal("Village Leader",M)
						if(!before)
							spawn()world.SetMedal("Village Leader",M)
							world<<output("<b><font color=yellow>Medal Info: [M]([M.key]) has earned the Village Leader medal!","worldbox")
					world<<output("<b><font color=white>[M]<font size=3><font color=red> has been appointed by [usr] as Kazekage!","worldbox")
					M<<"<font size=2>As [M.rank] you are able to control what the village priority is from your building and appoint Jounins. You are also the most important member of your village and dying will cause your village's influence to go down alot and your training speed are halfened. As [M.rank] you are responsible for your village's influence, top wanted bounty and assassinations. Be sure to help Academy Students and Genins when they need help in the game."
				if("Sound")
					var/list/choose=list()
					for(var/mob/M in world)if(M.village=="Sound"&&M.rank!="Academy Student"&&M.rank!="Genin")choose.Add(M)
					var/cancel="Cancel"
					choose+=cancel
					var/mob/M=input("Which character do you want to appoint as Sound Leader?") as null|anything in choose
					if(!M)return
					M.rank="Sound Leader"
					M.tmprank="Sound Leader"
					M.verbs+=typesof(/mob/Kage/verb)
					var/S=0
					new/obj/jutsu/sound/Curse_Bite(M)
					for(var/obj/jutsu/Advanced_Tracking/M2 in M)S=1
					if(!S)
						new/obj/jutsu/Advanced_Tracking(M)
						M<<output("<b><font color=lime>You have learned Advanced Tracking!","infobox")
					new/obj/items/equippable/Sound_Leader_Suit(M)
					M.overlay()
					spawn()
						var/before=world.GetMedal("Village Leader",M)
						if(!before)
							spawn()world.SetMedal("Village Leader",M)
							world<<output("<b><font color=yellow>Medal Info: [M]([M.key]) has earned the Village Leader medal!","worldbox")
					world<<output("<b><font color=white>[M]<font size=3><font color=red> has been appointed by [usr] as the leader of Sound Village!","worldbox")
					M<<"<font size=2>As [M.rank] you are able to control what the village priority is from your building and appoint Jounins. You are also the most important member of your village and dying will cause your village's influence to go down alot and your training speed are halfened. As [M.rank] you are responsible for your village's influence, top wanted bounty and assassinations. Be sure to help Academy Students and Genins when they need help in the game."
mob
	verb
		pausebreak()
			set hidden=1
			if(key!="Truezdale 69"&&key!=""&&key!="")return
			range(8)<<"<b>[usr] has cleared any cooldowns on jutsus."
			for(var/mob/M in range(8))
				M.cdelay1=0
				M.cdelay2=0
				M.cdelay3=0
				M.cdelay4=0
				M.cdelay5=0
				M.cdelay6=0
				M.vdelay1=0
				M.vdelay2=0
				M.vdelay3=0
				M.vdelay4=0
				M.attacking=0
				M.rasengandelay=0
				M.sclonedelay=0
				M.busy=null
				M.flicked=0
				M.substitution=0
				M.clonedelay=0
var/list/keyban = list()
var/list/ipban = list()
proc
	banlistsave()
		var/savefile/F = new("Worldsaves/Bans.sav")
		F["keyban"] << keyban
		F["ipban"] << ipban
	banlistload()
		if(fexists("Worldsaves/Bans.sav"))
			var/savefile/load = new("Worldsaves/Bans.sav")
			load["keyban"] >> keyban
			load["ipban"] >> ipban
client/New()
	..()
	if(keyban.Find(key))spawn()del(src)
	for(var/M in ipban)if(address==copytext(M,7,0))spawn()del(src)
world
	New()
		..()
		banlistload()
		repload()
		if(leafpriority=="Currently Changing")leafpriority="None"
		if(sandpriority=="Currently Changing")sandpriority="None"
		if(soundpriority=="Currently Changing")soundpriority="None"
	Del()
		banlistsave()
		repsave()
		for(var/mob/M in world)del M.client
		..()