mob/verb/Create_Guild()
	set category="Guild"
	if(village=="None")
		src<<output("You must be in a village or an organization to own a guild!","infobox")
		return
	if(rank=="Genin"||rank=="Chunin"||rank=="Academy Student")
		src<<output("You must be a Jounin or higher to own a guild!","infobox")
		return
	if(ryo<2500000)
		src<<output("Sorry, but creating a guild requires 1,500,000 ryo. You have [ryo] ryo.","infobox")
		return
	if(in_guild)return
	switch(alert("Are you sure that you want to create a guild? It costs 1,500,000 ryo.","","Yes","No"))
		if("Yes")
			var/guildfontban=list("<font","<br>")
			var/guildname=input("What do you want to name your guild?","") as text
			if(!guildname)return
			for(var/M in guildfontban)if(findtext(guildname,M))return
			if(lentext(guildname)>25)
				alert("The guild name can not be over 25 characters long!")
				return
			guild_name=guildname
			guild_rank="Guildmaster"
			in_guild=1
			for(var/mob/G in world)if(G.village==village)G<<output("<b><font color=aqua>[src] has created the guild [guild_name]!","worldbox")
			guildbothon()
			ryo-=1500000
mob/guild
	leader/verb
		Guild_Invite()
			set category="Guild"
			var/list/invitelist=list()
			for(var/mob/player/M in world)
				if(!M.client)continue
				if(M.name!=name)if(!M.in_guild)if(M.village==village)invitelist.Add(M)
			var/mob/M=input("Who do you want to invite to your guild? They must be in your home village.","") as null|anything in invitelist
			if(!M)return
			switch(alert(M,"[src] has sent you a guild invitation to the guild [guild_name]. Do you accept their guild invitation? Guild ","","Yes","No"))
				if("Yes")
					M.guild_name=guild_name
					M.guild_rank="Member"
					M.in_guild=1
					M.verbs+=typesof(/mob/guild/member/verb)
					for(var/mob/G in world)if(G.village==village)G<<output("<b><font color=aqua>[M] has joined [src]'s guild, [guild_name]!","worldbox")
				if("No")
					src<<output("[M] has rejected your guild invitation.","infobox")
					return
		Guild_Boot()
			set category="Guild"
			var/list/Menu=list()
			for(var/mob/M in world)
				if(!M.client)continue
				if(M.name!=name)if(M.in_guild)if(M.guild_name == guild_name)Menu.Add(M)
			var/mob/M=input("Who do you want to boot from the guild?","") as null | anything in Menu
			if(!M)return
			if(M.guild_rank=="Guildmaster")
				alert("You can not boot the guildmaster!")
				return
			switch(alert("Are you sure you want to kick [M] out of your guild?","","Yes","No"))
				if("Yes")
					for(var/mob/G in world)if(G.village==village)G<<output("<b><font color=aqua>[src] has kicked [M] out of the guild [guild_name]!","worldbox")
					M.guildbothoff()
					M.guild_name="None"
					M.guild_rank=""
					M.in_guild = 0
				if("No")return
		Change_Rank()
			set category="Guild"
			var/list/Menu = list()
			for(var/mob/M in world)
				if(!M.client) continue
				if(M.name != name)if(M.in_guild)if(M.guild_name == guild_name)Menu.Add(M)
			var/mob/M = input("Who's rank do you want to change?","") as null | anything in Menu
			if(!M)return
			if(istype(M,/mob))
				if(M.rank=="")
					alert("You can not change the guildmaster's rank!")
					switch(input("What rank do you wish to give [M]?")in list("Deputy Leader","Member","Custom","Cancel"))
						if("Deputy Leader")
							M.guildleaderon()
							M.guild_rank = "Deputy Leader"
							for(var/mob/X in world)if(X.guild_name==guild_name)X << output("<b><font color=aqua>[src] has changed [M]'s guild rank to Deputy Leader!","worldbox")
						if("Member")
							M.guildleaderoff()
							M.guild_rank = "Member"
							for(var/mob/X in world)if(X.guild_name==guild_name)X << output("<b><font color=aqua>[src] has changed [M]'s guild rank to Member!","worldbox")
						if("Cancel")return
		Guild_Announce(T as text)
			set category="Guild"
			var/list/L
			L = list("font size")
			if(lentext(T) > 400)
				alert("Your message must be less than 400 characters!")
				return
			for(var/X in L)if(findtext(T,X))
				alert("You can not change your font size.")
				return
			for(var/mob/X in world)if(X.guild_name == guild_name)X<<output("<font size=2><font color=silver><b><center>[src] would like to announce to the guild:<center><br>[T]","worldbox")
	member/verb
		Guild_Say(T as text)
			set category="Guild"
			var/list/L
			L = list("font size")
			if(lentext(T) > 300)
				alert("Your message must be less than 300 characters!")
				return
			for(var/X in L)
				if(findtext(T,X))
					alert("You can not change your font size.")
					return
			for(var/mob/X in world)if(X.guild_name == guild_name)X <<output("<b><font color=yellow>(Guild Say)([guild_rank])[name]: [T]","worldbox")
		Guild_Who()
			set category="Guild"
			var/tmp/C = 0
			src << output("<font size=1><b><font color=silver><center>---------------------GUILD WHO------------------------","worldbox")
			for(var/mob/M in world)if(M.in_guild&&M.guild_name==guild_name)
				C++
				src<<output("<font size=1><b><font color=red>[M.name]([M.key])([M.guild_rank])-[M.clan]-[M.rank]","worldbox")
			src << output("<b><font color=red>[C] Guild Members Online!","worldbox")
			src << output("<font size=1><b><font color=silver><center>---------------------GUILD WHO------------------------","worldbox")
		Guild_Leave()
			set category="Guild"
			switch(alert("Are you sure you want to leave the Guild [guild_name]?","","Yes","No"))
				if("Yes")
					guildbothoff()
					world << output("<b><font color=aqua>[src] has left the guild [guild_name]!","worldbox")
					guild_name = ""
					guild_rank = ""
					in_guild = 0
				if("No")return
mob/proc
	guildbothoff()
		verbs-=typesof(/mob/guild/leader/verb)
		verbs-=typesof(/mob/guild/member/verb)
	guildleaderoff()verbs-=typesof(/mob/guild/leader/verb)
	guildbothon()
		verbs+=typesof(/mob/guild/member/verb)
		verbs+=typesof(/mob/guild/leader/verb)
	guildleaderon()verbs+=typesof(/mob/guild/leader/verb)
